/*  %kw # %v    %n    %d    %t #             */
/* Version # 2    DEMO.H    5-Aug-94    11:27:52 # */

/*******************************************************/
/*         Metagraphics Software Corporation           */
/*             Copyright (c) 1987-1993                 */
/*******************************************************/
/* PURPOSE: module contains structures and globals     */
/*******************************************************/

#define VERSION "Demo V4.4"

/* =================== Menu Settings ====================== */

#ifdef DMOMAIN

menus  GUI_menu[] = {
/*-------------------------------------------------------------*/
/*--- Menu Bar Name -- Items -- Enables ---- Internal Use -----*/
/*-------------------------------------------------------------*/
   {
      {"&About"},    {       2}, {  0x03},  {0},{0,0,0,0},{0,0,0,0},  
      {"About &Demo", "About &Metagraphics " },
   },
         
   {
      {"&View"},     {       7}, { 0xFFF},  {0},{0,0,0,0},{0,0,0,0},  
      {"&Logo","&Hilbert","&Bouncy Ball","Space &Wire",
       "&Sketch","&Kaleid","&Graph" },
   },

   {      
      {"&Features"}, {       9}, { 0xFFF},  {0},{0,0,0,0},{0,0,0,0},  
      {"&Objects","&Raster Ops","&Clipping","&Patterns",
       "C&ursors","&Text","&Event System","Pa&lette","PC&X-Lab"},
   },

   {
      {"&Support"},  {       5}, { 0xFFF},  {0},{0,0,0,0},{0,0,0,0},  
      {"&Display Adapters","&Input Devices","&Hardcopy Devices",
       "&Platforms","&Languages " },
   },

   {
      {"&Info"},     {       5}, { 0xFFF},  {0},{0,0,0,0},{0,0,0,0},  
      {"&Product Overviews","&Function Call List","&User Comments",
       "&International Dealers","&Third Party Products" },
   },

   {
      {"&Run"},      {       4}, { 0xFFF},  {0},{0,0,0,0},{0,0,0,0},  
      {"&One Pass","&Auto Pilot","&Record","&Quit" },
   }


};

int numMenus = sizeof( GUI_menu ) / sizeof( menus );

#else
extern menus   GUI_menu[];
extern int     numMenus;
#endif


/* menu codes */
#define mgMenu        0
#define mgDemo        0
#define mgMeta        1

#define vwMenu        1
#define vwLogo        0
#define vwHilbert     1
#define vwBall        2
#define vwStar        3
#define vwSketch      4
#define vwText        5
#define vwGraph       6

#define feMenu        2
#define feObjects     0
#define feRasterops   1
#define feClip        2
#define fePatterns    3
#define feCursors     4
#define feText        5
#define feEvent       6
#define feColor       7
#define fePCXLab      8

#define spMenu        3
#define spDisplay     0
#define spInput       1
#define spHardcopy    2
#define spOS          3
#define spLanguage    4

#define ifMenu        4
#define ifProdOv      0
#define ifFuncs       1
#define ifUsers       2
#define ifReps        3
#define ifOrder       4

#define rnMenu        5
#define rnPass        0
#define rnAuto        1
#define rnRecord      2
#define rnQuit        3

/* =================== Global Variables ====================== */

#ifdef DMOMAIN
# define XTERN
#else
# define XTERN   extern
#endif

XTERN char dmoScript[80];

XTERN struct {
   int play;                /* running flag */
   int record;              /* recording flag */
   int forever;             /* keep running flag */
   FILE *fp;                /* script file pointer */
   unsigned short timebase; /* time delta <> script and real */
   int lastX, lastY;        /* last recorded mouse position */
   int dx, dy;              /* min mouse delta before record new */
   long sclX, sclY;         /* scale factors for playback */
   mwEvent evnt;            /* playback event buffer */
} script;

XTERN char dmoScript[80];  /* file name of script file */     

/* =================== Global Functions ====================== */

/* DMOMAIN */
   void MetaMenu     ( void );

/* DMOVIEW */
   void ViewMenu     ( void );

/* DMOFEAT */
   void FeatureMenu  (void);

/* DMOSPRT */
   void SupportMenu (void);

/* DMOINFO */
   void InfoMenu (void);

/* DMORUN */
   void RunMenu      ( void );
   void ScriptRecord ( void );
   void ScriptPlay   ( void );

/* DMOBAR */
   void bargraf (void);
   void Shadow  (char*, int, int, int, int, int);

/* DMOCOLOR */
   void Colorit(void);

/* DMOPCXR */
   void PCXLab( void );

/* DMOLOGO */
   void metlogo   (int);

/* DMOSHOW */
   void hilbert    ( void );
   void ball       ( int hits, int loops );

/* DMOWIRE */
   void wired      ( void );
   int  bewired    ( int );

/* DMOCLYDE */
   void kaleid     ( void );

/* DMOSKET */
   void metaSketch ( void );
