/*  %kw # %v    %n    %d    %t #             */
/* Version # 3    DMOCLYDE.C    15-Nov-93    11:32:06 # */
/******************************************************/
/*         Metagraphics Software Corporation           */
/*             Copyright (c) 1987-1993                 */
/*******************************************************/
/* FILE:    DMOCLYDE.C                                 */
/* PURPOSE: 60s retro demo                             */
/*******************************************************/

#include <stdlib.h>
#include <stdio.h>

#include "metawndo.h"
#include "GUIconst.h"
#include "GUIextrn.h"

#include "demo.h"


                   /* calculation only */
#define abs(x)  (((x)<0) ? -(x) : (x))
#define nabs(x) (((x)>0) ? -(x) : (x))
#define KSCOPE                  0x00
#define FAN                     0x01
#define DoLine(a,b,c,d)         MoveTo(a,b);  LineTo(c,d);
#define CheckBorder(xy,s,dir)   if ((xy) > max || (xy) < min) { \
                                    (dir) *= -1;                \
                                    (s) = (xy) += 2*(dir);    }

/*
**              kaleid()
**
**  Draw nifty patterns with lines.
*/
void kaleid()
{
   long sets, setsize, iterations, virtual, maxdelta, maxsize, type, memory;
   int nobreak = True;
   

   while( nobreak ) {
   
      switch( rand() % 9 ) {
         case 0:   /* slow kaleid */
            sets       = 3;         setsize  = 100;
            virtual    = 1000;      maxdelta = 12;
            iterations = 8; maxsize  = 100;
            type       = KSCOPE;    memory   = True;
            break;

         case 1:
         case 2:   /* sparkler kaleid */
            sets       = 4;         setsize  = 100;
            virtual    = 1000;      maxdelta = 12;
            iterations = 25;        maxsize  = 17;
            type       = KSCOPE;    memory   = True;
            break;

         case 3:   /* fast kaleid */
            sets       = 3;         setsize  = 10;
            virtual    = 1000;      maxdelta = 12;
            iterations = 80;        maxsize  = 100;
            type       = KSCOPE;    memory   = True;
            break;

         case 4:   /* fan */
            sets       = 3;         setsize  = 100;
            virtual    = 1000;      maxdelta = 12;
            iterations = 15;        maxsize  = 100;
            type       = FAN;       memory   = True;
            break;
#if 0
         case 5:  /* small solids - not getting maxsize */
            sets       = 20;        setsize  = 150;
            virtual    = 10000;     maxdelta = 8;
            iterations = 150;       maxsize  = 15;
            type       = FAN;       memory   = False;
            break;
#endif

         case 6:
         case 7:   /* sparkler */
            sets       = 4;         setsize  = 100;
            virtual    = 1000;      maxdelta = 12;
            iterations = 50;        maxsize  = 12;
            type       = FAN;       memory   = True;
            break;
         case 8:    /* small solid kaleid - not getting maxsize */
            sets       = 20;        setsize  = 150;
            virtual    = 10000;     maxdelta = 8;
            iterations = 30;        maxsize  = 15;
            type       = KSCOPE;    memory   = False;
            break;

         default:
            sets       = 3;         setsize  = 10;
            virtual    = 1000;      maxdelta = 12;
            iterations = 80;        maxsize  = 100;
            type       = KSCOPE;    memory   = True;
            break;
      }

      nobreak = do_kaleid( sets, setsize, virtual, maxdelta,
                           iterations, maxsize, type, memory );
   }

}


int do_kaleid( sets, setsize, virtual, maxdelta, iterations, maxsize, fan, memory )
long sets;              /* number of line sets on screen     */
long setsize;           /* number of lines per set           */
long virtual;           /* size of virtual port (0,0,V,V)    */
long maxdelta;          /* maximum delta of each point       */
long iterations;        /* number of times through outerloop */
long maxsize;           /* maximum line size (% of port)     */
long fan;               /* fan == 1, kaleidoscope == 0       */
long memory;            /* save lines & remove one at a time */
{
    grafPort   *gp;
    rect        direction, R, *set;
    int         innerloop, outerloop;
    int         FColor = White;
    int         i, index, maxColor;
    int         maxline, totaldelta, min, max;
    int         x1, y1, x2, y2;
    int         mirx1, miry1, mirx2, miry2;
    int         loop;


    BackColor( Black );
    GetPort( &gp );

        /* * *  SET NECESSARY PORT ATTRIBUTES  * * */
   
    SetRect( &R, 0, 0, (int)virtual, (int)virtual );
    VirtualRect( &R );
    ProtectRect( &R );  /* protect the screen */
    EraseRect( &R );    /* clear the screen */
    ProtectRect( NULL );  /* protect the screen */

    BackColor( Black );
    RasterOp( zREPz );
    PenSize( 1, 1 );

        /* * *  INIT KALEID VARS  * * */

    if ( memory )
    {
        if ( sets > iterations )
            sets = iterations;
        set  = (rect *)malloc( (int)sets*(int)setsize*sizeof(rect) );
        maxline = (sets * setsize) - 1;
    }
    else /* no memory */
    {
        set = &R;
        maxline = 0;
    }

    totaldelta = (maxdelta * 2) + 1;
    maxColor   = QueryColors();
    max        = virtual;
    min        = 0;
    index      = 0;
    if      ( maxsize >= 100 )  maxsize = virtual;
    else if ( maxsize <=   5 )  maxsize = (5 * virtual) / 100;
    else                        maxsize = (maxsize * virtual) / 100;

      /* clear the line set buffer */
    for ( index=0 ; index < maxline ; index++ ) {
        set[index].Xmin = 0;    set[index].Ymin = 0;
        set[index].Xmax = 0;    set[index].Ymax = 0;
    }

      /* seed the line set buffer */
    set[maxline].Xmin = rand() % max;  /* do not use SetRect !!! */
    set[maxline].Ymin = rand() % max;
    set[maxline].Xmax = rand() % max;
    set[maxline].Ymax = rand() % max;
    if ( abs(set[maxline].Xmax - set[maxline].Xmin) > maxsize )
    {
        if ( set[maxline].Xmax > set[maxline].Xmin )
            set[maxline].Xmin = set[maxline].Xmax - maxsize;
        else
            set[maxline].Xmin = set[maxline].Xmax + maxsize;
    }
    if ( abs(set[maxline].Ymax - set[maxline].Ymin) > maxsize )
    {
        if ( set[maxline].Ymax > set[maxline].Ymin )
            set[maxline].Ymin = set[maxline].Ymax - maxsize;
        else
            set[maxline].Ymin = set[maxline].Ymax + maxsize;
    }


    loop= True;
    for ( outerloop=0 ; (outerloop<iterations) && (loop>False); outerloop++ )
    {

          /*  new line color, never use black  */
        if ( maxColor > 1 )
            FColor = (rand() % maxColor) + 1;

          /*  set new direction  :::  do not use SetRect()!  */
        direction.Xmin = (rand() % totaldelta) - maxdelta;
        direction.Ymin = (rand() % totaldelta) - maxdelta;
        direction.Xmax = (rand() % totaldelta) - maxdelta;
        direction.Ymax = (rand() % totaldelta) - maxdelta;

          /*  wrap the index around the buffer  */
        if ( index  >= maxline ) index  = 0;

          /*  draw new lines & erase old lines  */
        for ( innerloop=0 ; innerloop < setsize ; innerloop++, index++ )
        {
                /* * * ERASE AN OLD LINE * * */

          if ( memory ) {

            ProtectRect( &R ); /* protect the screen */

            x1 = set[index].Xmin;                 /* get the next erase line */
            y1 = set[index].Ymin;
            x2 = set[index].Xmax;
            y2 = set[index].Ymax;

            PenColor ( Black );                   /* set background color    */
            DoLine(    x1,    y1,    x2,    y2 );       /* normal line       */

           if ( ! fan ) {
            mirx1 = max - x1;                     /* calculate mirror values */
            miry1 = max - y1;
            mirx2 = max - x2;
            miry2 = max - y2;

            DoLine( mirx1,    y1, mirx2,    y2 );       /*      mirror x     */
            DoLine( mirx1, miry1, mirx2, miry2 );       /*      mirror x & y */
            DoLine(    x1, miry1,    x2, miry2 );       /*      mirror     y */

            DoLine(    y1,    x1,    y2,    x2 );       /* diagonal line     */
            DoLine( miry1,    x1, miry2,    x2 );       /*      mirror x     */
            DoLine( miry1, mirx1, miry2, mirx2 );       /*      mirror x & y */
            DoLine(    y1, mirx1,    y2, mirx2 );       /*      mirror     y */
           } /* !fan */

            ProtectRect( NULL );

          } /* memory */

                /* * *  CALCULATE AND STORE NEXT LINE  * * */

          if ( memory ) {
            if ( abs(set[index-1].Xmax - set[index-1].Xmin) > maxsize )
            {
                if ( set[index-1].Xmax > set[index-1].Xmin )
                {
                    direction.Xmin = abs(direction.Xmin);
                    direction.Xmax = nabs(direction.Xmax);
                }
                else
                {
                    direction.Xmin = nabs(direction.Xmin);
                    direction.Xmax = abs(direction.Xmax);
                }
            }
            if ( abs(set[index-1].Ymax - set[index-1].Ymin) > maxsize )
            {
                if ( set[index-1].Ymax > set[index-1].Ymin )
                {
                    direction.Ymin = abs(direction.Ymin);
                    direction.Ymax = nabs(direction.Ymax);
                }
                else
                {
                    direction.Ymin = nabs(direction.Ymin);
                    direction.Ymax = abs(direction.Ymax);
                }
            }

            if ( index != 0 )
            {           /*  next line = previous line + offset  */
                x1 = set[index].Xmin = set[index-1].Xmin + direction.Xmin;
                CheckBorder( x1, set[index].Xmin, direction.Xmin );

                y1 = set[index].Ymin = set[index-1].Ymin + direction.Ymin;
                CheckBorder( y1, set[index].Ymin, direction.Ymin );

                x2 = set[index].Xmax = set[index-1].Xmax + direction.Xmax;
                CheckBorder( x2, set[index].Xmax, direction.Xmax );

                y2 = set[index].Ymax = set[index-1].Ymax + direction.Ymax;
                CheckBorder( y2, set[index].Ymax, direction.Ymax );
            }
            else /* index == 0 */
            {           /*  make sure to wrap around line set buffer  */
                x1 = set[0].Xmin = set[maxline].Xmin + direction.Xmin;
                CheckBorder( x1, set[0].Xmin, direction.Xmin );

                y1 = set[0].Ymin = set[maxline].Ymin + direction.Ymin;
                CheckBorder( y1, set[0].Ymin, direction.Ymin );

                x2 = set[0].Xmax = set[maxline].Xmax + direction.Xmax;
                CheckBorder( x2, set[0].Xmax, direction.Xmax );

                y2 = set[0].Ymax = set[maxline].Ymax + direction.Ymax;
                CheckBorder( y2, set[0].Ymax, direction.Ymax );
            } /* index ?= 0 */
          }
          else  /* no memory */
          {
            if ( abs(set[0].Xmax - set[0].Xmin) > maxsize )
            {
                if ( set[0].Xmax > set[0].Xmin )
                {
                    direction.Xmin = abs(direction.Xmin);
                    direction.Xmax = nabs(direction.Xmax);
                }
                else
                {
                    direction.Xmin = nabs(direction.Xmin);
                    direction.Xmax = abs(direction.Xmax);
                }
            }
            if ( abs(set[0].Ymax - set[0].Ymin) > maxsize )
            {
                if ( set[0].Ymax > set[0].Ymin )
                {
                    direction.Ymin = abs(direction.Ymin);
                    direction.Ymax = nabs(direction.Ymax);
                }
                else
                {
                    direction.Ymin = nabs(direction.Ymin);
                    direction.Ymax = abs(direction.Ymax);
                }
            }

                    /*  next line = previous line + offset  */
            x1 = set[0].Xmin = set[0].Xmin + direction.Xmin;
            CheckBorder( x1, set[0].Xmin, direction.Xmin );

            y1 = set[0].Ymin = set[0].Ymin + direction.Ymin;
            CheckBorder( y1, set[0].Ymin, direction.Ymin );

            x2 = set[0].Xmax = set[0].Xmax + direction.Xmax;
            CheckBorder( x2, set[0].Xmax, direction.Xmax );

            y2 = set[0].Ymax = set[0].Ymax + direction.Ymax;
            CheckBorder( y2, set[0].Ymax, direction.Ymax );
          } /* memory */

                /* * *  DRAW THE NEXT LINE * * */

            ProtectRect( &R ); /* protect the screen */

            PenColor ( FColor );                  /* set forground color     */
            DoLine(    x1,    y1,    x2,    y2 );       /* normal line       */

            ProtectRect( NULL );

            if ( fan )  continue;

            mirx1 = max - x1;                     /* calculate mirror values */
            miry1 = max - y1;
            mirx2 = max - x2;
            miry2 = max - y2;

            ProtectRect( &R ); /* protect the screen */

            DoLine( mirx1,    y1, mirx2,    y2 );       /*      mirror x     */
            DoLine( mirx1, miry1, mirx2, miry2 );       /*      mirror x & y */
            DoLine(    x1, miry1,    x2, miry2 );       /*      mirror     y */

            DoLine(    y1,    x1,    y2,    x2 );       /* diagonal line     */
            DoLine( miry1,    x1, miry2,    x2 );       /*      mirror x     */
            DoLine( miry1, mirx1, miry2, mirx2 );       /*      mirror x & y */
            DoLine(    y1, mirx1,    y2, mirx2 );       /*      mirror     y */

            ProtectRect( NULL ); /* protect the screen */

        }

      /* check for an event */
      if( PeekGUIEvent( 1 ) )
         loop = False;
         
    }


  if ( memory )
  {
        /* * *  CLEAN UP SCREEN ONE LINE AT A TIME  * * */

    PenColor ( Black );                   /* set background color    */
    for ( i=index ; i <= maxline ; i++ )
    {
        x1 = set[i].Xmin;                 /* get the next erase line */
        y1 = set[i].Ymin;
        x2 = set[i].Xmax;
        y2 = set[i].Ymax;

        ProtectRect( &R ); /* protect the screen */
        DoLine(    x1,    y1,    x2,    y2 );   /* normal line       */
        ProtectRect( NULL );

        if ( fan )  continue;

        mirx1 = max - x1;                     /* calculate mirror values */
        miry1 = max - y1;
        mirx2 = max - x2;
        miry2 = max - y2;

        ProtectRect( &R ); /* protect the screen */

        DoLine( mirx1,    y1, mirx2,    y2 );   /*      mirror x     */
        DoLine( mirx1, miry1, mirx2, miry2 );   /*      mirror x & y */
        DoLine(    x1, miry1,    x2, miry2 );   /*      mirror     y */

        DoLine(    y1,    x1,    y2,    x2 );   /* diagonal line     */
        DoLine( miry1,    x1, miry2,    x2 );   /*      mirror x     */
        DoLine( miry1, mirx1, miry2, mirx2 );   /*      mirror x & y */
        DoLine(    y1, mirx1,    y2, mirx2 );   /*      mirror     y */

        ProtectRect( NULL );

    }
    for ( i=0 ; i <= index ; i++ )
    {
        x1 = set[i].Xmin;                 /* get the next erase line */
        y1 = set[i].Ymin;
        x2 = set[i].Xmax;
        y2 = set[i].Ymax;

        ProtectRect( &R ); /* protect the screen */
        DoLine(    x1,    y1,    x2,    y2 );   /* normal line       */
        ProtectRect( NULL );
        if ( fan )  continue;

        mirx1 = max - x1;                     /* calculate mirror values */
        miry1 = max - y1;
        mirx2 = max - x2;
        miry2 = max - y2;

        ProtectRect( &R ); /* protect the screen */
        DoLine( mirx1,    y1, mirx2,    y2 );   /*      mirror x     */
        DoLine( mirx1, miry1, mirx2, miry2 );   /*      mirror x & y */
        DoLine(    x1, miry1,    x2, miry2 );   /*      mirror     y */

        DoLine(    y1,    x1,    y2,    x2 );   /* diagonal line     */
        DoLine( miry1,    x1, miry2,    x2 );   /*      mirror x     */
        DoLine( miry1, mirx1, miry2, mirx2 );   /*      mirror x & y */
        DoLine(    y1, mirx1,    y2, mirx2 );   /*      mirror     y */
        ProtectRect( NULL );  /* protect the screen */
    }

    free( set );
  }
  else /* no memory */
  {
        SetLocal();
        DupRect( &gp->portRect, &R );
        x1 = x2 = (R.Xmax - R.Xmin)/2 + R.Xmin;
        y1 = y2 = (R.Ymax - R.Ymin)/2 + R.Ymin;
        mirx1 = R.Xmin;   mirx2 = R.Xmax;
        miry1 = R.Ymin;   miry2 = R.Ymax;
        PenColor( Black );
        index = (R.Xmax - R.Xmin)/4+1;
        i = (R.Ymax - R.Ymin)/4+1;
        if ( index > i ) i = index;
        while ( i >= 0 )
        {
            i--;
            ProtectRect( &R ); /* protect the screen */
            DoLine( x1,      R.Ymin,  x1,      R.Ymax );    x1--;
            DoLine( x2,      R.Ymin,  x2,      R.Ymax );    x2++;
            DoLine( R.Xmin,  y1,      R.Xmax,  y1     );    y1--;
            DoLine( R.Xmin,  y2,      R.Xmax,  y2     );    y2++;
            DoLine( mirx1,   R.Ymin,  mirx1,   R.Ymax );    mirx1++;
            DoLine( mirx2,   R.Ymin,  mirx2,   R.Ymax );    mirx2--;
            DoLine( R.Xmin,  miry1,   R.Xmax,  miry1  );    miry1++;
            DoLine( R.Xmin,  miry2,   R.Xmax,  miry2  );    miry2--;
            ProtectRect( NULL );

        }
  }

   return loop;
   
}    /* kaleid () */


/* end-of-file dmoclyde.c */
