/*  %kw # %v    %n    %d    %t #             */
/* Version # 4    DMOFEAT.C    10-Nov-93    15:13:02 # */
/*******************************************************/
/*         Metagraphics Software Corporation           */
/*             Copyright (c) 1987-1990                 */
/*******************************************************/
/* FILE:    dmofeat.c                                  */
/* PURPOSE: implements features menu                   */
/*******************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "metawndo.h"
#include "GUIconst.h"
#include "GUIextrn.h"

#include "demo.h"

void Objects      (void);
void Rops         (void);
void Clipit       (void);
void Patit        (void);
void Cursit       (void);
void Textit       (void);
void Eventit      (void);

static void doRop( int rop, rect *sR, rect *dR );
static char *state2string( unsigned short );
long int FontImageSize( fontRcd *srcFont, int srcChar );
void ReadFontImage( fontRcd *srcFont, int srcChar, imageHeader *dstImage );

void FeatureMenu()
{
   
   grafPort *viewPort;

   /* size a bounding box */
   DupRect( &scrnPort->portRect, &viewDlgBox.BoundRect );
   InsetRect( &viewDlgBox.BoundRect, picX( 100 ), picY(100) );

   switch( opSelect.selItem ) {

      case feObjects:
         GUIWindow( &viewDlgBox, " MetaWINDOW Objects " );
         Objects();
         break;

      case feRasterops:
         GUIWindow( &viewDlgBox, " Raster Ops " );
         Rops();
         break;

      case feClip:
         GUIWindow( &viewDlgBox, " Clipping " );
         Clipit();
         break;

      case fePatterns:
         GUIWindow( &viewDlgBox, " Patterns " );
         Patit();
         break;

      case feCursors:
         GUIWindow( &viewDlgBox, " Cursors " );
         Cursit();
         break;

      case feText:
         GUIWindow( &viewDlgBox, " Text " );
         Textit();
         break;
      
      case feEvent:
         GUIWindow( &viewDlgBox, " Event System " );
         Eventit();
         break;

      case feColor:
         GUIWindow( &viewDlgBox, " Colors " );
         Colorit();
         break;

      case fePCXLab:
         GUIWindow( &viewDlgBox, " PCX-Lab " );
         PCXLab();
         break;

      default:
            return;
    }

   /* chuck the window port  */
   GetPort( &viewPort );
   SetPort( scrnPort );
   free( viewPort );

   /* wait for a close */
   while( True ) {

      KeyGUIEvent( True );

      /* check close box button or keypress  */
      if( CheckClose( &viewDlgBox ) )
         break;
   }

   /* close window */
// CloseWindow( &viewDlgBox );
   RegenDesk();



}

void Objects()
{
   rect wR, tR;
   int tc, dx, dy;
   polyHead ph;
   point pts[10], pbuf[10];
   grafPort *gp;
   region *myregion1, *myregion2, *myregion3;

   GetPort( &gp );

   SetRect( &wR, 0, 0, 100, 100 );
   VirtualRect( &wR );

   ProtectRect( &wR );

   TextAlign( alignCenter, alignBottom );
   tc = colors->text;

   /* rects */
   SetRect( &tR, 5, 8, 20, 28 );
   MoveTo( 25, tR.Ymin - 2 );
   PenColor( tc );
   BackColor( White );
   DrawString("Rectangle");

   PenColor(Black);
   FrameRect( &tR );
   OffsetRect( &tR, 25, 0 );
   PenColor( 1 );
   BackColor( 2 );
   FillRect( &tR, 8 );


   OffsetRect( &tR, 25, 0 );
   MoveTo( 75, tR.Ymin - 2 );
   PenColor( tc );
   BackColor( White );
   DrawString("Round Rect");

   dx = (tR.Xmax - tR.Xmin ) / 4;
   dy = (tR.Ymax - tR.Ymin ) / 4;
   PenColor(Black);
   FrameRoundRect( &tR, dx, dy );
   OffsetRect( &tR, 25, 0 );
   PenColor( 3 );
   BackColor( 4 );
   FillRoundRect( &tR, dx * 2, dy * 2, 9 );


   /* ovals */
   SetRect( &tR, 5, 41, 20, 61 );
   MoveTo( 25, tR.Ymin - 2 );
   PenColor( tc );
   BackColor( White );
   DrawString("Ovals");

   PenColor(Black);
   FrameOval( &tR );
   OffsetRect( &tR, 25, 0 );
   PenColor( 5 );
   BackColor( 6 );
   FillOval( &tR, 10 );


   OffsetRect( &tR, 25, 0 );
   MoveTo( 75, tR.Ymin - 2 );
   PenColor( tc );
   BackColor( White );
   DrawString("Arcs");

   PenColor(Black);
   FrameArc( &tR, 200, 700 );
   OffsetRect( &tR, 25, 0 );
   PenColor( 7 );
   BackColor( 8 );
   FillArc( &tR, 200, 700, 11 );

   /* polygons */
   ph.polyBgn = 0;
   ph.polyEnd = 8;
   ph.polyRect = gp->portRect;
   pts[0].X = 13; pts[0].Y = 74;
   pts[1].X = 6;  pts[1].Y = 80;
   pts[2].X = 16; pts[2].Y = 83;
   pts[3].X = 20; pts[3].Y = 91;
   pts[4].X = 13; pts[4].Y = 88;
   pts[5].X = 9;  pts[5].Y = 94;
   pts[6].X = 10; pts[6].Y = 91;
   pts[7].X = 6;  pts[7].Y = 87;
   pts[8].X = 11; pts[8].Y = 84;

   for( dx = 0; dx < 9; dx++ ) {
      pbuf[dx].X = pts[dx].X + 25;
      pbuf[dx].Y = pts[dx].Y;
   }

   SetRect( &tR, 5, 74, 20, 95 );
   MoveTo( 25, tR.Ymin - 2 );
   PenColor( tc );
   BackColor( White );
   DrawString("Polygons");

   PenColor( Black );
   FramePoly( 1, &ph, &pts[0] );

   PenColor( 9 );
   BackColor( 10 );
   FillPoly( 1, &ph, &pbuf[0], 12 );

   /* lines */
   OffsetRect( &tR, 50, 0 );
   MoveTo( 62, tR.Ymin - 2 );
   PenColor( tc );
   BackColor( White );
   DrawString("Lines");

   PenColor( Black );
   PenSize( 3, 3 );
   PenShape( shapeOval );
   PenCap( capRound );
   MoveTo( tR.Xmin, tR.Ymin );
   LineTo( 73, 90 );
   PenSize( penThin );

   /* regions */
   MoveTo( 87, tR.Ymin - 2 );
   PenColor( tc );
   BackColor( White );
   DrawString("Regions");


   OpenRegion();
   SetRect( &tR, 77,74, 88, 86 );
   FillRect( &tR, 1 );
   SetRect( &tR, 80,80, 95, 98 );
   FillRect( &tR, 1 );
   myregion1 = CloseRegion();

   OpenRegion();
   SetRect( &tR, 83, 85, 92, 96);
   FillOval( &tR, 1 );
   myregion2 = CloseRegion();

   myregion3 = SubtractRegion( myregion1, myregion2 );

   PenColor( 9 );
   BackColor( 10 );
   FillRegion( myregion3, 6 );

   GrafFree( myregion1 ); GrafFree( myregion2 ); GrafFree( myregion3 );

   ProtectRect( NULL );

   SetLocal();
}

void Rops()
{
   
   rect wR, sR, dR;

   SetRect( &wR, 0, 0, 200, 200 );
   VirtualRect( &wR );

   ProtectRect( &wR );

   TextAlign( alignCenter, alignBottom );
   PenColor( colors->text );
   BackColor( White );

   /* first group */
   MoveTo( 12, 10 );
   DrawString("REPlace");
   MoveTo( 37, 10 );
   DrawString("AND");
   MoveTo( 62, 10 );
   DrawString("OR");
   MoveTo( 87, 10 );
   DrawString("XOR");
   MoveTo( 112, 10 );
   DrawString("Not-REP");
   MoveTo( 137, 10 );
   DrawString("Not-AND");
   MoveTo( 162, 10 );
   DrawString("Not-OR");
   MoveTo( 187, 10 );
   DrawString("Not-XOR");

   /* second group */

   MoveTo( 12, 60 );
   DrawString("AND-Not");
   MoveTo( 37, 60 );
   DrawString("NANDN");
   MoveTo( 62, 60 );
   DrawString("OR-Not");
   MoveTo( 87, 60 );
   DrawString("NORN");
   MoveTo( 112, 60 );
   DrawString("CLEAR");
   MoveTo( 137, 60 );
   DrawString("SET");
   MoveTo( 162, 60 );
   DrawString("INVERT");
   MoveTo( 187, 60 );
   DrawString("NOP");

   /* third group */
   MoveTo( 12, 110 );
   DrawString("T-REP");
   MoveTo( 37, 110 );
   DrawString("T-AND");
   MoveTo( 62, 110 );
   DrawString("T-OR");
   MoveTo( 87, 110 );
   DrawString("T-XOR");
   MoveTo( 112, 110 );
   DrawString("T-NREP");
   MoveTo( 137, 110 );
   DrawString("T-NAND");
   MoveTo( 162, 110 );
   DrawString("T-NOR");
   MoveTo( 187, 110 );
   DrawString("T-NXOR");

   /* fourth group */
   MoveTo( 12, 160 );
   DrawString("T-ANDN");
   MoveTo( 37, 160 );
   DrawString("TNANDN");
   MoveTo( 62, 160 );
   DrawString("TORN");
   MoveTo( 87, 160 );
   DrawString("TNORN");
   MoveTo( 112, 160 );
   DrawString("TCLEAR");
   MoveTo( 137, 160 );
   DrawString("TSET");
   MoveTo( 162, 160 );
   DrawString("TINVERT");
   MoveTo( 187, 160 );
   DrawString("TNOP");


   PenColor( Black );
   SetRect( &sR, 4, 24, 16, 44 );
   SetRect( &dR, 10, 16, 22, 36 );

   doRop( zREPz, &sR, &dR );
   doRop( zANDz, &sR, &dR );
   doRop( zORz, &sR, &dR );
   doRop( zXORz, &sR, &dR );
   doRop( zNREPz, &sR, &dR );
   doRop( zNANDz, &sR, &dR );
   doRop( zNORz, &sR, &dR );
   doRop( zNXORz, &sR, &dR );

   /* second line */

   SetRect( &sR, 4, 74, 16, 94 );
   SetRect( &dR, 10, 66, 22, 86 );

   doRop( zANDNz, &sR, &dR );
   doRop( zNANDNz, &sR, &dR );
   doRop( zORNz, &sR, &dR );
   doRop( zNORNz, &sR, &dR );
   doRop( zCLEARz, &sR, &dR );
   doRop( zSETz, &sR, &dR );
   doRop( zINVERTz, &sR, &dR );
   doRop( zNOPz, &sR, &dR );

   /* third line */

   SetRect( &sR, 4, 124, 16, 144 );
   SetRect( &dR, 10, 116, 22, 136 );

   doRop( xREPx, &sR, &dR );
   doRop( xANDx, &sR, &dR );
   doRop( xORx, &sR, &dR );
   doRop( xXORx, &sR, &dR );
   doRop( xNREPx, &sR, &dR );
   doRop( xNANDx, &sR, &dR );
   doRop( xNORx, &sR, &dR );
   doRop( xNXORx, &sR, &dR );

   /* fourth line */
   SetRect( &sR, 4, 174, 16, 194 );
   SetRect( &dR, 10, 166, 22, 186 );

   doRop( xANDNx, &sR, &dR );
   doRop( xNANDNx, &sR, &dR );
   doRop( xORNx, &sR, &dR );
   doRop( xNORNx, &sR, &dR );
   doRop( xCLEARx, &sR, &dR );
   doRop( xSETx, &sR, &dR );
   doRop( xINVERTx, &sR, &dR );
   doRop( xNOPx, &sR, &dR );

   ProtectRect( NULL );


}

static void doRop( int rop, rect *sR, rect *dR )
{
    RasterOp( zREPz );
    PenPattern( 12 );
    PaintRect( dR );
    RasterOp( rop );
    PenPattern( 17 );
    PaintRect( sR );
    OffsetRect( sR, 25, 0 );
    OffsetRect( dR, 25, 0 );
}

void Clipit()
{

   rect wR, cR;
   grafPort *wPort, *tmpPort;
   int x,y;
   region *myregion1, *myregion2, *myregion3;
   dialogBox clipDia;
   int line;

   GetPort( &wPort );
   DupRect( &wPort->portRect, &wR );
   line = wPort->txFont->lnSpacing;
   wR.Ymin += line * 2;

   ProtectRect( &wR );

   PenColor( colors->text );
   BackColor( White );
   TextAlign( alignCenter, alignBottom );
   MoveTo( (wR.Xmax + wR.Xmin ) / 2, wR.Ymin );
   DrawString( "Full Rectangular Clipping of all Graphics" );

   cR.Ymin = wR.Ymin;
   cR.Ymax = (wR.Ymax + wR.Ymin ) / 4;

   for( y = 0; y < 4; y++ ) {

      cR.Xmax = (wR.Xmax + wR.Xmin ) / 4;
      cR.Xmin = wR.Xmin;

      for( x = 0; x < 4; x++ ) {

         ProtectRect( &wR );
         BackColor( White );
         EraseRect( &wR );
         ClipRect( &cR );
         bargraf();
         ClipRect( &wR );
         PenColor( Black );
         FrameRect( &cR );
         ProtectRect( NULL );
         delay( 5 );
         OffsetRect( &cR, (wR.Xmax - wR.Xmin ) / 4, 0);
      }

      OffsetRect( &cR, 0, (wR.Ymax - wR.Ymin ) / 4 );
   }

   /* region clipping */
   ClipRect( &wPort->portRect );

   DupRect( &wR, &clipDia.BoundRect );
   InsetRect( &clipDia.BoundRect, picX( 75 ), picY( 75 ) );

   GUIWindow( &clipDia, "Region Clipping" );

   GetPort( &tmpPort );
   DupRect( &tmpPort->portRect, &wR );
   ProtectRect( &wR );

   TextAlign( alignCenter, alignBottom );
   x = (wR.Xmax + wR.Xmin ) / 2;
   MoveTo( x, line * 2 );
   DrawString("Region Clipping allows");
   MoveTo( x, line * 3 );
   DrawString("clipping of irregular shaped");
   MoveTo( x, line * 4 );
   DrawString("areas, like overlapped windows.");
   ProtectRect( NULL );

   /* chuck the small window port - return to window port */
   SetPort( wPort );
   free( tmpPort );


   OpenRegion();
   FillRect( &wPort->portRect, 1 );
   myregion1 = CloseRegion();

   OpenRegion();
   FillRect( &clipDia.BoundRect, 1 );
   myregion2 = CloseRegion();

   myregion3 = SubtractRegion( myregion1, myregion2 );
   GrafFree( myregion1 ); GrafFree( myregion2 );

   ClipRegion( myregion3 );
   ball( 20, 0 );
   ClipRegion( NULL );
   GrafFree( myregion3 );

   HideCursor();
   EraseRect( &wPort->portRect );
   ShowCursor();
}

void Patit()
{
    int x, y, dx, dy;
    int num, pc;
    rect wR, tR, pR;
    grafPort *wPort;


    GetPort( &wPort );
    DupRect( &wPort->portRect, &wR );

    ProtectRect( &wR );

    DupRect( &wR, &tR );
    dx = (tR.Xmax - tR.Xmin) / 8;
    dy = (tR.Ymax - tR.Ymin) / 4;
    tR.Xmax = tR.Xmin + dx;
    tR.Ymax = tR.Ymin + dy;

    num = 0; pc = 1;
    BackColor( Black );

    for( y = 0; y < 4; y++ ) {

        DupRect( &tR, &pR );
        OffsetRect( &pR, 0, y * dy );

        for( x = 0; x < 8; x++ ) {

            if( pc % ( QueryColors() + 1 ) == Black )
                pc++;
            PenColor( pc++ );

            FillRect( &pR, num++ );
            OffsetRect( &pR, dx, 0 );

        }

    }

    PenColor( colors->text );
    BackColor( White );

    TextAlign( alignCenter, alignBottom );
    MoveTo( (wR.Xmax - wR.Xmin ) / 2, wR.Ymin + picY( 40 ) );
    DrawString( "32 Pre-Defined Patterns, or Build Your Own!" );

    ProtectRect( NULL );

}

void Cursit()
{
   rect          wR;
   int           line, x, j, lastcur;
   unsigned int  sittime; 
   int           xlast, y, i;
   grafPort     *wPort;
   fontRcd      *doggieFile;
   long int      doggieSize;
   imageHeader  *doggieImage[8];
   imageHeader  *doggieMask[8];
   

   GetPort( &wPort );
   DupRect( &wPort->portRect, &wR );
   line = wPort->txFont->lnSpacing;
   PenColor( colors->text );

   TextAlign( alignLeft, alignBaseline );
   x = wR.Xmin + wPort->txFont->chWidth;
   y = wR.Ymin + line;

   MoveTo( x, y );
   HideCursor();
   DrawString( "Automatic mouse/cursor tracking..." );
   delay(20);

   y += line;
   MoveTo( x, y );
   DrawString( "User defined mouse limits and scaling...");
   delay(20);

   y += line;
   MoveTo( x, y );
   DrawString( "User defined areas protected from cursors...");
   delay(20);

   y += line;
   MoveTo( x, y );
   DrawString( "User defined cursor colors...");
   delay(20);

   y += line;
   MoveTo( x, y );
   DrawString("Eight pre-defined cursors:");
   ShowCursor();

   TrackCursor( False );
   MoveCursor( (wR.Xmax + wR.Xmin) / 2, (wR.Ymax + wR.Ymin) / 2 );
   TrackCursor( True );

   for( i = 0; i < 8; i++ ) {
      CursorStyle( i );
      delay(8);
    }

   CursorStyle( curCursor );
   
   y += line;
   MoveTo( x, y );

   HideCursor();
   DrawString("User defined cursors, up to 32x32 pixels...");
   ShowCursor();

/* DOGGIE TIME */

   /* load up doggie cursors from file  */

   doggieFile = (fontRcd *)malloc( 5000 );
   if( doggieFile == NULL )
      return;

   i = FileLoad( "bigdog.fnt", doggieFile, 5000 );
   if( i < 0 ) {
      free( doggieFile );
      return;
   }
   
   /* allocate image buffers for cursors 0-7 */
   doggieSize = FontImageSize( doggieFile, 1 );
   for( i = 0 ; i < 8 ; i++ ) {
      doggieImage[i] = doggieMask[i]  = (imageHeader *) NULL;
      doggieImage[i] = ( imageHeader * ) malloc( (int) doggieSize );
      doggieMask[i]  = ( imageHeader * ) malloc( (int) doggieSize );
      if( doggieImage[i] == NULL || doggieMask[i] == NULL ) 
         break;
    }    

   /* if any allocation fails, free all memory and return */
   if( i < 8 ) {
      free( doggieFile );
      for( i = 0 ; i < 8 ;i++ ) {
         if( doggieImage[i] != NULL )
            free( doggieImage[i] );
         if( doggieMask[i]  != NULL )
            free( doggieMask[i]  );
      }
      return;
    }

/* define cursors 0 - 5 as doggie movements */

   j = 1;
   for( i = 0; i < 6; i++ ) {
      ReadFontImage( doggieFile, j++, doggieImage[i] );
      ReadFontImage( doggieFile, j++, doggieMask[i] );
      DefineCursor( i, 8, 8, ( cursor *) doggieImage[i],
                             ( cursor *) doggieMask[i] );
   }
   

   /* now, lets get cute */
   CursorColor( Red, Brown );
   lastcur = xlast = sittime = 0;
   while( True ) {
            
      if( PeekGUIEvent( 1 ) )
         break;

      x = opEvent.eventX;

      if( x > xlast+10 ) { /* move to right 0,1 */
         lastcur = (lastcur==0) ? 1 : 0;
         CursorStyle( lastcur );
         sittime = opEvent.eventTime + 20;
         xlast = x;
      }

      if( x < xlast-10) {  /* move to left 2,3 */
         lastcur = (lastcur==2) ? 3 : 2;
      	CursorStyle( lastcur );
         sittime = opEvent.eventTime + 20;
         xlast = x;
      }

      if( sittime < opEvent.eventTime ) {  /* sit, boy 4,5 */
         lastcur = (lastcur==4) ? 5 : 4;
      	CursorStyle( lastcur );
         sittime = opEvent.eventTime + 20;
      }


   } 

   /* select normal cursor */
   CursorColor( White, Black );
   CursorStyle( curCursor );

   /* restore standard cursors */
   for( i=0 ; i < 8 ; i++ )
      DefineCursor( i, 0, 0, NULL, NULL );

   /* free all doggie buffers */
   free( doggieFile );
   for( i = 1; i < 8; i++ ) {
      free( doggieImage[i] );
      free( doggieMask[i]  );
   }
}

void Textit()
{

    rect wR;
    int line, x, y, i, j;
    grafPort *wPort;
    char *fntbuf;
    char *title;

    GetPort( &wPort );
    DupRect( &wPort->portRect, &wR );
    line = sysFont->lnSpacing;
    PenColor( colors->text );

    TextAlign( alignLeft, alignBaseline );
    TextFace( cProportional );
    x = wR.Xmin + sysFont->chWidth;
    y = wR.Ymin + line;

    /* bitmapped */
    MoveTo( x, y );
    HideCursor();
    DrawString( "Bitmapped text is fast drawing," );
    y += line;
    MoveTo( x, y );
    DrawString( "can be proportionally spaced," );
    y += line;
    MoveTo( x, y );
    DrawString( "and has synthesized facings.");
    y += line;
    MoveTo( x, y );
    TextFace( cBold+cProportional );
	 DrawString( "This is bold facing.");
    y += line;
    MoveTo( x, y );
    TextFace( cItalic+cProportional );
    TextMode( zANDz );
    DrawString( "This is italic facing");
    y += line;
    MoveTo( x, y );
    TextFace( cUnderline+cProportional );
    DrawString( "This is underline facing.");
    y += line;
    MoveTo( x, y );
    TextFace( cStrikeout+cProportional );
    DrawString( "This is strikeout facing.");
    y += line;
    MoveTo( x, y );
    TextFace( cHalftone+cProportional );
    DrawString( "This is halftone facing.");

    TextFace( cProportional );

    /* stroked */
    delay(10);
    y += line * 2;
    MoveTo( x, y );
	 PenColor( Red );
    DrawString( "Stroked fonts can be dynamically" );
    y += line;
    MoveTo( x, y );
    DrawString( "scaled to any size or orientation.");
    ShowCursor();

    fntbuf = (char *)malloc( (unsigned int) 10000 );
    if( fntbuf == NULL )
        return;
    /* load the file */
    i = FileLoad( "romantri.fnt", fntbuf, 10000 );
    if( i <= 0 )
        return;
    /* make it the active font */
    SetFont( (fontRcd *)fntbuf );

    title = "Metawindow graphics solutions";

    TextAngle( 0 );
    TextFace( cNormal );
    i = picX( 10 );
    j = 900;

    MoveTo( 3 * (wR.Xmax - wR.Xmin) / 4, (wR.Ymax - wR.Ymin) / 2 );

    HideCursor();
    while( *title ) {

        TextSize( i, i );
        TextPath( j );
        DrawChar( *title );
        i++;
        j -= 240;

        title++;
	 }

    ShowCursor();
    free( fntbuf );
   

/* next page */

   /* flush queue */
   while( PeekGUIEvent( 1 ) )
      KeyGUIEvent( True );

   /* wait for any event */
   KeyGUIEvent( True );

   HideCursor();

   SetFont( sysFont );
   PenColor( colors->text );
   TextPath( pathRight );
   TextFace( cProportional );
   EraseRect( &wR );

   y = wR.Ymin + ( 2 * line );
   x = (wR.Xmax - wR.Xmin) / 2;

   TextAlign( alignCenter, alignBaseline );
   MoveTo( x, y );
   DrawString( "Text alignment to the pen location is variable" );

   TextAlign( alignLeft, alignBaseline );
   x = wR.Xmin + sysFont->chWidth;
   y += 2 * line;
   MoveTo( x, y );
   DrawString( "Text may be aligned four ways vertically..." );
   delay(5);

   y += 2 * line;
   MoveTo( x, y );

   PenColor( Red );
   TextAlign( alignLeft, alignTop );
   DrawString( "Align Top" );

   MoveRel( sysFont->chWidth*2, 0 );
   TextAlign( alignLeft, alignMiddle );
   PenColor( Green );
   DrawString( "Align Middle" );
   delay(5);

   MoveRel( sysFont->chWidth*2, 0 );
   TextAlign( alignLeft, alignBaseline );
   PenColor( Blue );
   DrawString( "Align Baseline" );
   delay(5);

   MoveRel( sysFont->chWidth*2, 0 );
   TextAlign( alignLeft, alignBottom );
   PenColor( Cyan );
   DrawString( "Align Bottom" );
   delay(5);

   PenColor( Black );
   LineTo( x,y );
   delay(20);


   y += 4 * line;
   MoveTo( x, y );
   DrawString( "Text may be aligned three ways horizontally..." );
   delay(5);

   x = (wR.Xmax - wR.Xmin) / 2;
   i = y + line;
   y += 2 * line;

   MoveTo( x, y );
   PenColor( Red );
   TextAlign( alignLeft, alignBaseline );
   DrawString( "Align Left" );

   y += 2 * line;
   MoveTo( x, y );
   TextAlign( alignCenter, alignBaseline );
   PenColor( Green );
   DrawString( "Align Center" );
   delay(5);

   y += 2 * line;
   MoveTo( x, y );
   TextAlign( alignRight, alignBaseline );
   PenColor( Blue );
   DrawString( "Align Right" );
   delay(5);

   PenColor( Black );
   MoveTo( x, i );
   LineTo( x,y );

   ShowCursor();

/* next page */

   /* flush queue */
   while( PeekGUIEvent( 1 ) )
      KeyGUIEvent( True );

   /* wait for any event */
   KeyGUIEvent( True );

   HideCursor();

   PenColor( colors->text );
   EraseRect( &wR );

   y = wR.Ymin + ( 2 * line );
   x = (wR.Xmax - wR.Xmin) / 2;

   TextAlign( alignCenter, alignBaseline );
   MoveTo( x, y );
   DrawString( "The direction of the text path is variable" );
   y += 2 * line;
   delay(5);

   PenColor( Black );
   MoveTo( x, y );
   LineTo( x, wR.Ymax - line );
   y = (y + wR.Ymax - line ) / 2;
   MoveTo( x - (wR.Xmin + sysFont->chWidth * 10 ), y );
   LineTo( x + (wR.Xmin + sysFont->chWidth * 10 ), y );
   delay(5);

   TextAlign( alignLeft, alignBaseline );

   TextFace( cNormal );

   PenColor( Red );
   MoveTo( x, y );
   TextPath( pathRight );
   DrawString( " Path Right" );
   delay(5);

   PenColor( Cyan );
   MoveTo( x, y );
   TextPath( pathDown );
   DrawString( " Path Down" );
   delay(5);

   PenColor( Green );
   MoveTo( x, y );
   TextPath( pathLeft );
   DrawString( " Path Left" );
   delay(5);

   PenColor( Blue );
   MoveTo( x, y );
   TextPath( pathUp );
   DrawString( " Path Up" );
   delay(5);


   ShowCursor();

}

void Eventit()
{
   
	rect wR;
	int line, x, y;
	point gpt;
	char buf[80], *s;
	grafPort *wPort;

	GetPort( &wPort );
	DupRect( &wPort->portRect, &wR );
	line = wPort->txFont->lnSpacing;
	PenColor( colors->text );

	TextAlign( alignLeft, alignBaseline );
	x = wR.Xmin + wPort->txFont->chWidth;
	y = wR.Ymin + line;

	MoveTo( x, y );
	HideCursor();
	DrawString( "Mouse, Keyboard, and User events are queued" );
	y += line;
	MoveTo( x, y );
	DrawString( "allowing programming in an event driven model.");
   delay(10);
	y += line;
	MoveTo( x, y );
	DrawString( "Selected types of events may be masked.");
	y += line * 2;
	ShowCursor();

   MaskEvent( evntALL );

	/* display events */
	while( True ) {

      /* wait for an event */
      while( !PeekGUIEvent( 1 ) )
         ;

      /* check close box */
      if( CheckClose( &viewDlgBox ) ) 
         break;

      /* pull it out */
      KeyGUIEvent( True );

      /* display it */
      PenColor( Black );

	   HideCursor();

      switch( opEvent.eventType ) {
         case evntMOVE:    s = "Move"; break;
         case evntPRESS:   s = "Button Press"; break;
         case evntRELEASE: s = "Button Release"; break;
         case evntKEYDN:   s = "Key Press"; break;
         case evntKEYUP:   s = "Key Release"; break;
         case evntUSER1:   s = "User Event 1"; break;
         case evntUSER2:   s = "User Event 2"; break;
         default:          s = "";
      }
	   MoveTo( x, y );
      DrawString( "Type = " );
      DrawString( s );
      DrawString( "             " );

	   MoveTo( x, y + line );
	   if( opEvent.eventChar > 0x20 && opEvent.eventChar < 0x7F )
	      sprintf( buf, "ASCII = `%c', ", opEvent.eventChar );
      else
	      sprintf( buf, "ASCII = %3d, ", opEvent.eventChar );
      DrawString( buf );
	   sprintf(buf, " Scancode = %2d,  State = %s",
				 opEvent.eventScan, state2string( opEvent.eventState ) );
	   DrawString( buf );
      DrawString( "             " );

	   MoveTo( x, y + 2 *line );
	   gpt.X = opEvent.eventX;
	   gpt.Y = opEvent.eventY;
	   Lcl2GblPt( &gpt );
	   sprintf(buf, "X = %3d  Y = %3d  Time = %5u  Buttons = %d",
				 gpt.X, gpt.Y, opEvent.eventTime, opEvent.eventButtons );
	   DrawString( buf );
      DrawString( "             " );
	   ShowCursor();
   
	}

   MaskEvent( evntPRESS + evntRELEASE + evntKEYDN );

}


void ReadFontImage( fontRcd *srcFont, int srcChar, imageHeader *dstImage )
/*
This routine reads the bitmap for character srcChar out of the font record
pointed to by srcFont, converts it to an image, and places at dstImage.
dstImage MUST be large enough to hold the resultant image. You can use
FontImageSize to compute the necessary image buffer size.
*/
{

    int i, row, shift;
    unsigned int *loc;
    unsigned char *imdata, *fontdata, *src;
    rect charRect;
    grafMap *fontBmap;


    /* if passed a null image buffer, don't do it! */
    if( dstImage == NULL )
        return;

    /* make a pointer to the fonts bitmap record */
    fontBmap = ( grafMap *) ( (long) srcFont + srcFont->grafMapTbl ); 

    /* make a pointer to the fonts location table */
    loc = ( unsigned int *) ( (long) srcFont + srcFont->locTbl ); 

    /* make a pointer to the font pixel data */
    fontdata = ( unsigned char *) ( (long) srcFont + srcFont->fontTbl ); 

    /* make a pointer to the image data buffer */
    imdata = ( ( unsigned char *) dstImage ) + sizeof( imageHeader );

    /* get a bounding rectangle for the character */
    i = srcChar - srcFont->minChar;
    SetRect( &charRect, loc[i], 0, loc[i+1], srcFont->chHeight );

    /* set the image header fields */
    dstImage->imWidth = charRect.Xmax - charRect.Xmin;
    dstImage->imHeight = charRect.Ymax - charRect.Ymin;
    dstImage->imAlign = 0;
    dstImage->imRowBytes = (dstImage->imWidth + 7) / 8;
    dstImage->imBits = (char) fontBmap->pixBits;
    dstImage->imPlanes = 1;

    /* get the data out of the font and into the image */

    /* calculate bits necessary to shift left */
    shift = charRect.Xmin % 8;

    /* for each row */
    for( row = 0; row < fontBmap->pixHeight; row++ ) {

        /* point to the font raster in question */
        src = fontdata + ( fontBmap->pixBytes * row );

        /* offset to first byte containing start of character */
        src +=  charRect.Xmin / 8;

        /* for each byte in a row */
        for( i = 0; i < dstImage->imRowBytes; i++ ) {

            /* shift it left and pack it into image data */
            *imdata = *src << shift;
            *imdata |= ( *(src+1) >> (8 - shift) );

            src++; imdata++;

        }

    }


}



long int FontImageSize( fontRcd *srcFont, int srcChar )
/*
This routine returns the number of bytes required to hold the image for
character srcChar in the font record pointed to by srcFont. This size
includes the image header structure
*/
{
    int i;
    unsigned int *loc;
    long fisize;

    /* make a pointer to the fonts location table */
    loc = ( unsigned int *) ( (long) srcFont + srcFont->locTbl ); 

    /* get an index into the location table for this character */
    i = srcChar - srcFont->minChar;

    /* compute number of bytes wide rounded to next word */  
    fisize = (long) ( (loc[i+1] - loc[i] + 15) / 8 );
    fisize *= (long) srcFont->chHeight;
    fisize += (long) sizeof( imageHeader );

    return fisize;

}

static char *state2string( unsigned short st )
{
    int i,j;
    static char state[20] = ".... .... .... ...." ;

    for ( i=15 ; i >= 0 ; i-- )
    {
        j = i + (i/4);
        if ( 1 & st )
            state[j] = '1';
        else
            state[j] = '.';
        st = st >> 1;
    }
    return state;
}


/* End Of File:  dmofeat.c */
