/*  %kw # %v    %n    %d    %t #             */
/* Version # 8    DMOLOGO.C    5-Aug-94    10:54:42 # */
/******************************************************/
/*         Metagraphics Software Corporation           */
/*             Copyright (c) 1987-1993                 */
/*******************************************************/
/* FILE:    dmologo.c                                  */
/* PURPOSE: module contains animated logo              */
/*******************************************************/

#include <stdio.h>
#include <conio.h>

#include "metawndo.h"
#include "GUIconst.h"
#include "GUIextrn.h"

#include "demo.h"

#include "pcxlab.h"

void BurstPalette( rect *burstR );

void metlogo( int do_text )
{

   rect        wR, dR;
   point       tP;
   grafPort    *thePort;
   pcxHead     pcxheader;
   char        *logofile;
   region      *myregion;

   logofile = "logo.pcx";

   GetPort(&thePort);
   DupRect( &thePort->portRect, &wR );
   
   BackColor( colors->desktop );
   EraseRect( &wR );

   /* center the dest rect on the port */
	if( ReadPCXInfo( logofile, &pcxheader, NULL ) == False )
      return;
   tP.X = wR.Xmax / 2;
   tP.Y = wR.Ymax / 2;
   CenterRect( &tP, pcxheader.pcxWndo.Xmax, pcxheader.pcxWndo.Ymax, &dR );

   ProtectRect( &dR );

   PenColor( Black );
   ReadPCX( logofile, NULL, &dR );

   myregion = BitmapToRegion( &dR, colors->desktop );
//   myregion = BitmapToRegion( &dR, Black );

   if( myregion == NULL )
      return;

   ClipRegion( myregion );

   BurstPalette( &wR );

   ResetGUIPalette();

   ClipRegion( NULL );

   GrafFree( myregion );

   ProtectRect( NULL );

}


                       // red grn blu
palData  palColors[] = { {152,  0,152},   // Table of defining color
                         {204,  0,  0},   // transition values.
                         {255,102,  0},
                         {255,255,  0},   // ('numIncr' defines the number
                         {  0,152,  0},   //  of increments between each
                         {  0,  0,204},   //  color transition value.)      
                         {255,255,255} };
int      numPalColors = 7;                // Number of entries in the table


palData  palTable[255];                   // Hardware palette table
palData  palTemp[255];  


void BurstPalette( rect *bR )
{

rect  R1;
int   i,j,k,iStep;
int   dly;
int   numIncr;                   // number of increments per color transition
int   maxColors;                 // maximum color index
int   bgnPal,endPal;             // beginning & ending palette entries to use
Word  incRed,incGreen,incBlue;   // color step increments


   maxColors = (int)QueryColors();  // get the maximum color value

   if ( maxColors == 255 )
      {                          // Select range of palette entries to use
      bgnPal  = 16;
      endPal  = 254;             //    if 256-color mode
      numIncr = 32; //(endPal-bgnPal+1)/8;
      dly = 0;
      }
   else
      {
      bgnPal  = 0;               //    if 16-color mode
      endPal  = 15;
      numIncr = 4;  //(endPal-bgnPal+1)/2;
      dly = 1;
      }


   // set palette entries to white to start
   for( i=bgnPal; i<=endPal; i++ )
      palTable[i].palRed = palTable[i].palGreen = palTable[i].palBlue = White;

   for( i=bgnPal; i<=endPal; i++ )
      palTemp[i] = palTable[i];

   MergeGUIPalette( palTemp );
   WritePalette( 0, bgnPal, endPal, &palTemp[bgnPal] );

#if 0
   // draw concentric circles
   i = bR->Xmax - bR->Xmin;
   j = bR->Ymax - bR->Ymin;
   if( i > j ) {
      k = (bR->Ymax + bR->Ymin) / 2;
      SetRect( &R1, bR->Xmin, k - i/2, bR->Xmax, k + i/2 );     
   }
   else {
      k = (bR->Xmax + bR->Xmin) / 2;
      SetRect( &R1, k - j/2, bR->Ymin, k + j/2, bR->Ymax );     
   }
#else
   // draw concentric ovals
   DupRect( bR, &R1 );
#endif

   InsetRect( &R1, -20, -20 );

   for( i = endPal; (R1.Xmin < R1.Xmax) && (R1.Ymin < R1.Ymax); i-- ) {

      if( i < bgnPal )
         i = endPal;

      if( i == colors->desktop || i == colors->bar  ||
          i == colors->text    || i == colors->high ||
          i == colors->low )
        continue;

      PenColor( i );         
      PaintOval( &R1 );      
      InsetRect( &R1, 1, 1 ); 

   }


   while( !PeekGUIEvent( 1 ) ) {  // Loop awhile

      //  Outer Loop for each color step
      for( iStep = 0; iStep < numPalColors; iStep++ ) {

         if( PeekGUIEvent( 1 ) )
            break;

         // Compute the color increments to the next step.
         // Word RGB values create carry and overflow problems when
         // we add and subtract.  We convert to byte values for the
         // calculation then convert back to Word RGB values.
         incRed   = ( ( (palTable[bgnPal].palRed   >> 8) -
                           palColors[iStep].palRed   ) / numIncr ) << 8;
         incGreen = ( ( (palTable[bgnPal].palGreen >> 8) -
                           palColors[iStep].palGreen ) / numIncr ) << 8;
         incBlue  = ( ( (palTable[bgnPal].palBlue  >> 8) -
                           palColors[iStep].palBlue  ) / numIncr ) << 8;
   
         // Loop for each color increment
         for( k = 0; k < numIncr; k++ ) {

            // rotate the palette colors
            for( i = endPal, j = endPal-1; i > bgnPal; i--,j-- )  {
               // shift the palette up
               palTable[i].palRed   = palTable[j].palRed;
               palTable[i].palGreen = palTable[j].palGreen;
               palTable[i].palBlue  = palTable[j].palBlue;
            }

            // increment to the new color
            palTable[bgnPal].palRed   -= incRed;
            palTable[bgnPal].palGreen -= incGreen;
            palTable[bgnPal].palBlue  -= incBlue;

            if( dly )
               delay(0);

            // write the new palette
            for( i=bgnPal; i<=endPal; i++ )
               palTemp[i] = palTable[i];
            MergeGUIPalette( palTemp );
            WritePalette( 0, bgnPal, endPal, &palTemp[bgnPal] );

            } // for (k... //
   
         } // for (iStep... //

      } // Loop awhile //


}
