/*  %kw # %v    %n    %d    %t #             */
/* Version # 5    DMOPCXR.C    10-Nov-93    17:34:04 # */
/*******************************************************/
/*         Metagraphics Software Corporation           */
/*             Copyright (c) 1987-1990                 */
/*******************************************************/
/* FILE:    dmopcxr.c                                  */
/* PURPOSE: implements PCX-Lab menu                    */
/*******************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>

#include "metawndo.h"
#include "GUIconst.h"
#include "GUIextrn.h"

#include "demo.h"

#include "pcxlab.h"


int  ScalePCX( char  *filename, rect *dest );


void PCXLab()
{
   int i, colors;
   unsigned time;
   char buf[100], *mem;
   int      line;

	pcxHead  pcxHeader;
	palData  RGBInfo[256];
	char     *pcxfile;
   rect     srcR, wR;

   dirRec   finfo;
   FILE     *fp;
   void     *pcxbuf;

	grafPort *wPort, offPort;
	grafMap  *origBitmap, offBitmap;



   colors = (int) QueryColors();
   switch( colors ) {

      case 15:
         pcxfile = "16.pcx";
         break;
      case 255:
         pcxfile = "256.pcx";
         break;
      default:
	   	Dialog( diaAlert, "No PCX files available", "for this display mode" );
         return;
   }


   GetPort( &wPort );
   DupRect( &wPort->portRect, &wR );
   line = wPort->txFont->lnSpacing;

	/* set palette, based on palette in PCX file */
	i = ReadPCXInfo( pcxfile, &pcxHeader, RGBInfo );
   if( i == False ) {
      Dialog( diaAlert, "Can't read PCX file", pcxfile );
      return;
   }

   /* merge GUI palette with files */
   MergeGUIPalette( RGBInfo );

   /* write the palette to display */
   WritePalette( 0, 0, colors, RGBInfo );

   /* read the file to display */
	CursorStyle(  watchCurs );
   ProtectRect( &wR );

   DupRect( &wR, &srcR );

   /* get time stamp */
   PeekGUIEvent( 10 );
   time = (unsigned) opEvent.eventTime;

   for( i = 0; i < 16; i++ ) {

   	if( ReadPCX( pcxfile, &srcR, NULL ) == False ) {
      	CursorStyle( curCursor );
         ProtectRect( NULL );
		   Dialog( diaAlert, "Problem reading PCX file:", pcxfile );
         break;
      }

      OffsetRect( &srcR, 50, 0 );
      if( srcR.Xmax > pcxHeader.pcxWndo.Xmax ) {
         srcR.Xmin = wR.Xmin;
         srcR.Xmax = wR.Xmax;
         OffsetRect( &srcR, 0, 50 );
         if( srcR.Ymax > pcxHeader.pcxWndo.Ymax )
            DupRect( &wR, &srcR );
      }

   }

   PeekGUIEvent( 10 );
   time = (unsigned) opEvent.eventTime - time;  /* time delta */
   time = time * 55;                            /* in msec */
   time = 16000 / time;                         /* frame/sec @ 16 frames */

	CursorStyle( curCursor );

   TextAlign( alignCenter, alignBaseline );
   MoveTo( (wR.Xmax + wR.Xmin ) / 2, wR.Ymin + (2 * line ) );
   DrawString( " PCX files can be displayed directly from disk " );
   MoveTo( (wR.Xmax + wR.Xmin ) / 2, wR.Ymin + (3 * line ) );
   sprintf( buf, " Reading file from disk = %d frames/second ", time );
   DrawString( buf );
   ProtectRect( NULL );

   FlushEvents();
   KeyGUIEvent( True );

	/* Read PCX File from buffer */

   FileQuery( pcxfile, &finfo, 1);
   pcxbuf = farmalloc( finfo.fileSize );
   if( pcxbuf == NULL ) {
		Dialog( diaAlert, "Not Enough Memory for", "Buffered PCX Read" );
      return;
   }

   fp = fopen( pcxfile, "rb" );
   fread( pcxbuf, 64000U, (size_t) (finfo.fileSize/64000L+1), fp );
   fclose( fp );


	CursorStyle(  watchCurs );
   ProtectRect( &wR );

   DupRect( &wR, &srcR );

   /* get time stamp */
   PeekGUIEvent( 10 );
   time = (unsigned) opEvent.eventTime;

   for( i = 0; i < 16; i++ ) {

   	if( GetPCX( pcxbuf, &srcR, NULL ) == False ) {
      	CursorStyle( curCursor );
         ProtectRect( NULL );
		   Dialog( diaAlert, "Problem reading PCX buffer", "" );
         break;
      }

      OffsetRect( &srcR, 50, 0 );
      if( srcR.Xmax > pcxHeader.pcxWndo.Xmax ) {
         srcR.Xmin = wR.Xmin;
         srcR.Xmax = wR.Xmax;
         OffsetRect( &srcR, 0, 50 );
         if( srcR.Ymax > pcxHeader.pcxWndo.Ymax )
            DupRect( &wR, &srcR );
      }

   }

   PeekGUIEvent( 10 );
   time = (unsigned) opEvent.eventTime - time;  /* time delta */
   time = time * 55;                            /* in msec */
   time = 16000 / time;                         /* frame/sec @ 16 frames */

	CursorStyle( curCursor );

   farfree( pcxbuf );

   MoveTo( (wR.Xmax + wR.Xmin ) / 2, wR.Ymin + (2 * line ) );
   DrawString( " PCX files can be displayed from file buffers in memory " );
   MoveTo( (wR.Xmax + wR.Xmin ) / 2, wR.Ymin + (3 * line ) );
   sprintf( buf, " Reading file from buffer = %d frames/second ", time );
   DrawString( buf );
   ProtectRect( NULL );

   /* flush buffer */
   FlushEvents();
   KeyGUIEvent( True );

	/* Read PCX File from offscreen */

   origBitmap = wPort->portMap; 

   /* make offscreen bitmap same dimensions as pcxfile */
   offBitmap.pixWidth  = pcxHeader.pcxWndo.Xmax;
   offBitmap.pixHeight = pcxHeader.pcxWndo.Ymax;
   offBitmap.pixBits   = origBitmap->pixBits;   
   offBitmap.pixPlanes = origBitmap->pixPlanes; 
   offBitmap.pixResX   = origBitmap->pixResX; 
   offBitmap.pixResY   = origBitmap->pixResY; 

   /* allocate the offscreen bitmap in regular memory */
   mem =  "memory";
   if( InitBitmap( cMEMORY, &offBitmap ) )  {

      CloseBitmap( &offBitmap );

      mem =  "EMS";
      if( InitBitmap( cEMS, &offBitmap ) )  {

         CloseBitmap( &offBitmap );

         mem =  "XMS";
         offBitmap.mapHandle = 0x8000L;  

         if( InitBitmap( cXMS, &offBitmap ) ) {
            CloseBitmap( &offBitmap );
      		Dialog( diaAlert, "Not Enough Memory for", "Offscreen PCX Read" );
            return;
         }

      }
      
   }

	CursorStyle(  watchCurs );

   /* assign ofscreen bitmap to a port */
   InitPort( &offPort );
   PortBitmap( &offBitmap );

   /* Read PCX File to the offscreen bitmap */
   i = ReadPCX( pcxfile, NULL, NULL );

   /* get screen port back */
   SetPort( wPort );

   if( i == False ) {
     	CursorStyle( curCursor );
      Dialog( diaAlert, "Problem reading PCX file:", pcxfile );
   }

   ProtectRect( &wR );

   DupRect( &wR, &srcR );

   /* get time stamp */
   PeekGUIEvent( 10 );
   time = (unsigned) opEvent.eventTime;

   for( i = 0; i < 16; i++ ) {

   	CopyBlit( &offPort, wPort, &srcR, &wR );

      OffsetRect( &srcR, 50, 0 );
      if( srcR.Xmax > pcxHeader.pcxWndo.Xmax ) {
         srcR.Xmin = wR.Xmin;
         srcR.Xmax = wR.Xmax;
         OffsetRect( &srcR, 0, 50 );
         if( srcR.Ymax > pcxHeader.pcxWndo.Ymax )
            DupRect( &wR, &srcR );
      }

   }

   PeekGUIEvent( 10 );
   time = (unsigned) opEvent.eventTime - time;  /* time delta */
   time = time * 55;                            /* in msec */
   time = 16000 / time;                         /* frame/sec @ 16 frames */

   CloseBitmap( &offBitmap );

	CursorStyle( curCursor );

   MoveTo( (wR.Xmax + wR.Xmin ) / 2, wR.Ymin + (2 * line ) );
   DrawString( " PCX files can be loaded into offscreen bitmaps " );
   MoveTo( (wR.Xmax + wR.Xmin ) / 2, wR.Ymin + (3 * line ) );
   sprintf( buf, " CopyBlit from offscreen %s bitmap = %d frames/second ",
                  mem,  time );
   DrawString( buf );
   ProtectRect( NULL );


   /* flush buffer */
   FlushEvents();
   KeyGUIEvent( True );


	/* scale PCX File */

	CursorStyle(  watchCurs );
   ProtectRect( &wR );

   if( ReadPCX( pcxfile, NULL, NULL ) == False ) {
      CursorStyle( curCursor );
      ProtectRect( NULL );
		Dialog( diaAlert, "Problem reading PCX file:", pcxfile );
      return;
   }


   /* read in scaled down */
   DupRect( &wR, &srcR );
   srcR.Ymax  = wR.Ymax / 3;
   srcR.Xmax  = wR.Xmax / 3;
   OffsetRect( &srcR, 10, 10 );

   if( ScalePCX( pcxfile, &srcR ) <= 0 ) {
		Dialog( diaAlert, "Problem scaling PCX file:", pcxfile );
      return;
   }


   /* read in scaled up */
   DupRect( &wR, &srcR );
   srcR.Ymin  = wR.Ymax * 2 / 3;
   srcR.Xmin  = wR.Xmax * 2 / 3;
   OffsetRect( &srcR, -10, -10 );
   ClipRect( &srcR );

   srcR.Ymin -= 100;
   srcR.Xmax -= 100;

   srcR.Ymax = wR.Ymax * 3;
   srcR.Xmax = wR.Xmax * 3;

   if( ScalePCX( pcxfile, &srcR ) <= 0 ) {
		Dialog( diaAlert, "Problem scaling PCX file:", pcxfile );
      return;
   }

   ClipRect( &wR );

	CursorStyle( curCursor );

   MoveTo( (wR.Xmax + wR.Xmin ) / 2, wR.Ymin + (2 * line ) );
   DrawString( " PCX files can be scaled up or down " );

   ProtectRect( NULL );

   /* flush buffer */
   FlushEvents();

   /* wait for event */
   while( !PeekGUIEvent( 1 ) )
      ;

   ResetGUIPalette();
}




/*
ScalePCX: read and scale a pcx file

Returns;
    1 = file read correctly
    0 = error reading PCX file
   -1 = not a valid pcx file
   -2 = can't allocate image buffer
   -3 = can't allocate translation buffer

*/

int  ScalePCX( char  *filename, rect *dstR )

{
   int       i, pcxHeight, y;
   pcxHead   pcxHeader;       /* buffer for reading the files PCX header */
   unsigned  imsize;          /* size of required image buffer           */
   image     *srcImage;       /* pointer to allocated source image buffer*/
   image     *dstImage;       /* pointer to allocated dest image buffer  */
   rect      wiR;             /* rectangle used to WriteImage() raster   */
   int       ratio, ratioCntr, xsize;   
   long     l;

   rect      clipR;
   grafPort   *thePort;

   /* Open the PCX File and read header information */
   imsize =  OpenPCX( filename, &pcxHeader, NULL );
   if( imsize == 0)
      return -1;     /* not  a valid pcx file */

   /* allocate an image buffer large enough for one raster of the pcx file */
   srcImage = malloc( imsize );
   if( srcImage == NULL ) {
      ClosePCX( &pcxHeader );
      return  -2;    /*  can't allocate */
   }

   /* calculate a translation image buffer size */

   /* get a  'taste' of the pcx files image format */
   NextPCX( &pcxHeader, srcImage );
   xsize = dstR->Xmax - dstR->Xmin;
   imsize  = (unsigned) ScaleImage( srcImage, NULL, xsize, 1  );
   dstImage = malloc( imsize );
   if( dstImage == NULL ) {
      free( srcImage );
      ClosePCX( &pcxHeader );
      return -3;     /*  can't allocate */
   }

   /* reset file to beginning */
   ClosePCX( &pcxHeader );
   OpenPCX( filename, &pcxHeader, NULL );

   /* get a clip rect */
   GetPort( &thePort );
   DupRect( &(thePort->portClip), &clipR );


   /* set up a rectangle for the destination WriteImage() */
   DupRect( dstR, &wiR );
   wiR.Ymax = wiR.Ymin + 1;

   /* compute number of rasters in the pcx file */
   pcxHeight = pcxHeader.pcxWndo.Ymax - pcxHeader.pcxWndo.Ymin + 1;

   /* compute fixed point ratio of dest rect size to pcx file size */
   l = (long) (dstR->Ymax - dstR->Ymin);
   l = l * 100L + (long) (pcxHeight - 1 );
   ratio  = (int) ( l / (long) pcxHeight );

   /* start off running total at 0 */
   ratioCntr = 0;

   /* process each pcx file raster individually */
   for( y = 0; y < pcxHeight; y++ ) {


      /* read next raster into an image buffer */
      i = NextPCX( &pcxHeader, srcImage );

      if( i == False )  {
         ClosePCX( &pcxHeader );
         free( srcImage );
         free( dstImage );
         return 0;      /* error reading */
      }

      /* advance by ratio amount */
      ratioCntr += ratio;

      /* as long as we have a whole part of a ratio count */
      while( ratioCntr / 100 ) {

         ratioCntr -= 100;    // do 1 whole unit,leave fractional part

         if( wiR.Ymax >= dstR->Ymax || wiR.Ymax >= clipR.Ymax )
            break;

         /* scale raster line */
         ScaleImage( srcImage, dstImage, xsize, 1 ); 

         /* write this raster line */
         WriteImage( &wiR, dstImage );
         OffsetRect( &wiR, 0, 1 );
      }


   } /* for Y */


   /* close the PCX file opened via OpenPCX */
   ClosePCX( &pcxHeader );

   /* free the image buffers */
   free( srcImage );
   free( dstImage );

   return 1;

}


