/*  %kw # %v    %n    %d    %t #             */
/* Version # 4    DMOSKET.C    10-Nov-93    17:34:52 # */
/******************************************************/
/*         Metagraphics Software Corporation           */
/*             Copyright (c) 1987-1993                 */
/*******************************************************/
/* FILE:    dmosket.c                                  */
/* PURPOSE: module contains the sketcher               */
/*******************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "metawndo.h"
#include "GUIconst.h"
#include "GUIextrn.h"

#include "demo.h"

/* meta sketch */
void metaSketch()
{
   int x,y;
   rect tR;
   point pointA, pointOld;
   grafPort *wPort;
   
   /* get bounding rect */
   GetPort( &wPort );
   DupRect( &wPort->portRect, &tR );

   /* we will be XORing */
   RasterOp(zXORz);
   PenColor( White );

   /* record the first point */
   pointOld.X =  pointA.X = x = tR.Xmin + picX( 25 );
   pointOld.Y =  pointA.Y = y = tR.Ymin + picY( 25 );

   /* draw initial spot */
   HideCursor();
   MoveTo( pointA.X, pointA.Y);
   LineTo( x, y );
   ShowCursor();

   /* drag an XOR around */
   while( True ) {
      
      /* check the event, is it real ? */
      if( PeekGUIEvent( 1 ) ) {

         /* check close box */
         if( CheckClose( &viewDlgBox ) ) 
            break;

         /* pull it out of the queue */
         KeyGUIEvent( False );
      }

      x = opEvent.eventX;
      y = opEvent.eventY;

      /* if not in the sketch area, ignore */
      if( !XYInRect( x, y, &tR ) )
         continue;

      /* button press: commit XOR line */            
      if( opEvent.eventType & evntPRESS  ) {

         RasterOp( zNREPz );
         HideCursor();
         MoveTo( pointA.X, pointA.Y);
         LineTo( pointOld.X, pointOld.Y );
         ShowCursor();
         RasterOp( zXORz );

         pointA.X = x;
         pointA.Y = y;

         continue;
      }

      /* if at a new point */
      if( pointOld.X != x || pointOld.Y != y  ) {

         HideCursor();
         /* remove old line */
         MoveTo( pointA.X, pointA.Y);
         LineTo( pointOld.X, pointOld.Y);
         /* draw new line */
         MoveTo( pointA.X, pointA.Y);
         LineTo( x, y );
         ShowCursor();

         pointOld.X = x;
         pointOld.Y = y;

      }   /* end of if new point */

   }  /* end of while( true ) */

}

/* end of meta sketch */

