/*  %kw # %v    %n    %d    %t #             */
/* Version # 4    DMOVIEW.C    10-Nov-93    15:18:14 # */
/******************************************************/
/*         Metagraphics Software Corporation           */
/*             Copyright (c) 1987-1993                 */
/*******************************************************/
/* FILE:    dmoview.c                                  */
/* PURPOSE: module contains view menus                 */
/*******************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "metawndo.h"
#include "GUIconst.h"
#include "GUIextrn.h"

#include "demo.h"

void ViewMenu()
{
   grafPort *viewPort;
   
   /* size a bounding box */
   DupRect( &scrnPort->portRect, &viewDlgBox.BoundRect );
   InsetRect( &viewDlgBox.BoundRect, picX( 100 ), picY(100) );
   
   switch( opSelect.selItem ) {

      case vwLogo:
         GUIWindow( &viewDlgBox, " Logo " );
         metlogo(True);
         break;

     case vwHilbert:
         GUIWindow( &viewDlgBox, " Hilbert " );
         hilbert( );
         break;

     case vwBall:
         GUIWindow( &viewDlgBox, " Bouncy Ball " );
         ball( 20, 0 );
         break;

     case vwStar:
         GUIWindow( &viewDlgBox, " Space Wire " );
         wired();
         break;

     case vwSketch:
         GUIWindow( &viewDlgBox, " Sketch " );
         metaSketch();
         break;

     case vwText:
         GUIWindow( &viewDlgBox, " Kaleidoscope " );
         kaleid();
         break;

     case vwGraph:
         GUIWindow( &viewDlgBox, " Bar Graph " );
         bargraf();
         break;

     default:
         return;

    }

   /* chuck the window port  */
   GetPort( &viewPort );
   SetPort( scrnPort );
   free( viewPort );

   /* wait for a close */
   while( True ) {

      KeyGUIEvent( True );

      /* check close box button or keypress  */
      if( CheckClose( &viewDlgBox ) )
         break;
   }

   /* close window */
// CloseWindow( &viewDlgBox );
   RegenDesk();

}


