/*  %kw # %v    %n    %d    %t #             */
/* Version # 4    DMOWIRE.C    10-Nov-93    15:18:24 # */
/******************************************************/
/*         Metagraphics Software Corporation           */
/*             Copyright (c) 1987-1993                 */
/*******************************************************/
/* FILE:    DMOWIRE.C                                  */
/* PURPOSE: module contains space wire                 */
/*******************************************************/

#include <stdio.h>
#include <stdlib.h>

#include "metawndo.h"
#include "GUIconst.h"
#include "GUIextrn.h"

#include "demo.h"


#define MAXPTS   10
#define DELTA    10
/*
**  Draw nifty patterns with lines.
*/

void wired()
{
   int nobreak = True;
   
   while( nobreak )
      nobreak = bewired( rand() % 8 + 2 );
}


int bewired( int npts )
{
   struct {
      int x;     int y;    /* current point              */
      int Dx;    int Dy;   /* Deltas                     */
      int x2;    int y2;   /* previous point             */
   } poly[MAXPTS];

   int i, j, loop;
   int FColor = White;
   int BColor = Black;
   int Xmax, Ymax, Xmin, Ymin;
   grafPort   *thePort;
                     
   GetPort(&thePort);
   Xmax = thePort->portRect.Xmax;
   Ymax = thePort->portRect.Ymax;
   Xmin = thePort->portRect.Xmin;
   Ymin = thePort->portRect.Ymin;
   

   BColor = rand() % 15;
   BackColor ( BColor );

   if ( npts > MAXPTS )
      npts = MAXPTS;
   else if( npts < 2 )
      npts = 2;
         
   /*  Initialize points and deltas to psuedo random numbers */
   for ( i = 0 ; i < npts ; i++ ) {
      poly[i].x  =  rand() % Xmax;
      poly[i].y  =  rand() % Ymax;
      if( BColor == Black ) {
         /* random angle and speed */
         poly[i].Dx = ((rand() % DELTA) + 1)*((rand() % 2) ? 1 : -1);
         poly[i].Dy = ((rand() % DELTA) + 1)*((rand() % 2) ? 1 : -1);
      }
      else {
         /* 45' angle constant speed */
         poly[i].Dx = (rand() % 2) ? (DELTA/2) : -(DELTA/2);
         poly[i].Dy = (rand() % 2) ? (DELTA/2) : -(DELTA/2);
      }
   }

   /* clear the screen */
   ProtectRect( &thePort->portRect );
   EraseRect( &thePort->portRect );
   ProtectRect( NULL );
   
   /* Draw the first polygon */
   RasterOp( zREPz );
   PenColor( FColor );
   MoveTo( poly[npts-1].x, poly[npts-1].y );
   for( i = 0 ; i < npts ; i++ ) {
      ProtectRect( &thePort->portRect );
      LineTo( poly[i].x, poly[i].y );
      ProtectRect( NULL );
   }

   i = 0;
   loop = True;

   while( loop ) {
      i++;
      if( i > 300 ) /* getting boring, restart */
         break;

      /* Save the current polygon */
      for( j = 0 ; j < npts ; j++ ) {
         poly[j].x2 = poly[j].x;
         poly[j].y2 = poly[j].y;
      }
      /* Make certain points don't go off port */
      for( j = 0 ; j < npts ; j++ ) {
         if( (poly[j].x > Xmax) || (poly[j].x < Xmin) )
            poly[j].Dx = -(poly[j].Dx);
         if( (poly[j].y > Ymax) || (poly[j].y < Ymin) )
            poly[j].Dy = -(poly[j].Dy);
      }  

      /* Increment points */
      for( j = 0 ; j < npts ; j++ ) {
         poly[j].x += poly[j].Dx;
         poly[j].y += poly[j].Dy;
      }

      /* Draw next polygon */
      ProtectRect( &thePort->portRect );
      MoveTo( poly[npts-1].x, poly[npts-1].y );
      for( j = 0 ; j < npts ; j++ )
         LineTo ( poly[j].x, poly[j].y );

      /* Remove previous polygon */
      PenColor( Black );
      MoveTo( poly[npts-1].x2, poly[npts-1].y2 );
      for( j = 0 ; j < npts ; j++ )
         LineTo ( poly[j].x2, poly[j].y2 );
      PenColor ( FColor );

      ProtectRect( NULL );

      /* check for an event */
	   if( PeekGUIEvent( 1 ) )
	      loop = False;
   }  

   ProtectRect( NULL );

   return loop;

}    /* spacewire ( npts ) */

